Codeforces 321B Ciel and Duel KM

题目链接

题意:

类似于游戏王的卡牌游戏,每个随从都有嘲讽。。。

输入n m

下面n行给出对手的随从当前状态和强壮值。

下面m行给出自己的随从的强壮值。

表示自己有m个随从,对手有n个随从。每个随从有一个强壮值。

现在是自己进攻的回合,自己的每个随从可以攻击一次(也可以不攻击)

若对手的随从都死光了,那么可以直接攻击玩家,造成与强壮值相等的伤害。

否则就要先攻击对手的随从。

对手的随从有防御状态(Defense) 和 攻击状态(Attack),每个随从也有一个强壮值。

1、若攻击对手的攻击状态随从X,必须满足自己的随从Y 强壮值>= X的强壮值,否则无法进行攻击。攻击结束后X死亡,并对对手造成 Y_val - X_val 的伤害。

2、若攻击对手的防御状态随从X,必须满足自己的随从Y强壮值严格>X 的强壮值,否则无法进行攻击。攻击结束后X死亡,不造成伤害。

问:

最大能造成多少伤害。

思路:

因为n只有100,所以首先想到KM

那么有2种情况,能把对面随从杀光和不能把对面随从杀光。

1、若不能杀光,则直接匹配即可, 若自己的随从i能杀死对面的随从j,则 (i,j)的边权为 i杀死j后造成的伤害,若不能则 (i,j) 的边权=0

2、若能杀光,则若自己的随从i能杀死对面的随从j,则 (i,j)的边权为 i杀死j后造成的伤害,若不能则 (i,j) 的边权=-inf,表示这条边不能选,即(i,j)不能匹配,然后富裕的己方随从和对面虚拟出等量的随从,边权为己方随从的强壮值,表示直接对玩家攻击,造成等于强壮值的伤害。

因此需要跑2次KM

#include <iostream>
#include <string>
#include <vector>
#include <cstring>
#include <cstdio>
#include <map>
#include <queue>
#include <algorithm>
#include <stack>
#include <cstring>
#include <cmath>
#include <set>
#include <vector>
using namespace std;
template <class T>
inline bool rd(T &ret) {
	char c; int sgn;
	if (c = getchar(), c == EOF) return 0;
	while (c != '-' && (c<'0' || c>'9')) c = getchar();
	sgn = (c == '-') ? -1 : 1;
	ret = (c == '-') ? 0 : (c - '0');
	while (c = getchar(), c >= '0'&&c <= '9') ret = ret * 10 + (c - '0');
	ret *= sgn;
	return 1;
}
template <class T>
inline void pt(T x) {
	if (x < 0) {
		putchar('-');
		x = -x;
	}
	if (x > 9) pt(x / 10);
	putchar(x % 10 + '0');
}
typedef long long ll;
typedef pair<int, int> pii;
const int inf = 1e9;
const int INF = 1e6;
const int N = 205;
const int M = 205;
int n, m;
int a[N], b[N];
bool p[N];
int nx, ny;
int link[M], lx[M], ly[M], slack[M];    //lx,ly为顶标,nx,ny分别为x点集y点集的个数
int visx[M], visy[M], w[M][M];

int DFS(int x)
{
	visx[x] = 1;
	for (int y = 1;y <= ny;y++)
	{
		if (visy[y])
			continue;
		int t = lx[x] + ly[y] - w[x][y];
		if (t == 0)       //
		{
			visy[y] = 1;
			if (link[y] == -1 || DFS(link[y]))
			{
				link[y] = x;
				return 1;
			}
		}
		else if (slack[y] > t)  //不在相等子图中slack 取最小的
			slack[y] = t;
	}
	return 0;
}
int KM()
{
	int i, j;
	memset(link, -1, sizeof(link));
	memset(ly, 0, sizeof(ly));
	for (i = 1;i <= nx;i++)            //lx初始化为与它关联边中最大的
		for (j = 1, lx[i] = -inf;j <= ny;j++)
		if (w[i][j] > lx[i])
		lx[i] = w[i][j];

	for (int x = 1;x <= nx;x++)
	{
		for (i = 1;i <= ny;i++)
			slack[i] = inf;
		while (1)
		{
			memset(visx, 0, sizeof(visx));
			memset(visy, 0, sizeof(visy));
			if (DFS(x))     //若成功(找到了增广轨),则该点增广完成,进入下一个点的增广
				break;  //若失败(没有找到增广轨),则需要改变一些点的标号,使得图中可行边的数量增加。
						//方法为:将所有在增广轨中(就是在增广过程中遍历到)的X方点的标号全部减去一个常数d,
						//所有在增广轨中的Y方点的标号全部加上一个常数d
			int d = inf;
			for (i = 1;i <= ny;i++)
				if (!visy[i] && d > slack[i])
				d = slack[i];
			for (i = 1;i <= nx;i++)
				if (visx[i])
				lx[i] -= d;
			for (i = 1;i <= ny;i++)  //修改顶标后,要把所有不在交错树中的Y顶点的slack值都减去d
				if (visy[i])
				ly[i] += d;
				else
					slack[i] -= d;
		}
	}
	int res = 0;
	for (i = 1;i <= ny;i++)
		if (link[i] > -1)
		res += w[link[i]][i];
	return res;
}
int main() {
	rd(n); rd(m);
	for (int i = 1; i <= n; i++) {
		char s[5]; scanf("%s", s); rd(a[i]);
		p[i] = s[0] == 'A';
	}
	for (int i = 1; i <= m; i++) rd(b[i]);

	nx = ny = max(n, m);
	memset(w, 0, sizeof w);
	for (int i = 1; i <= m; i++)
		for (int j = 1; j <= n; j++)
		{
			if (p[j])
			{
				if (b[i] >= a[j])w[i][j] = b[i] - a[j];
			}
		}

	int ans = KM();

	if (m > n) {
		for (int i = 1; i <= m; i++)
			for (int j = 1; j <= n; j++)
			{
				if (p[j])
				{
					if (b[i] >= a[j])w[i][j] = b[i] - a[j];
					else w[i][j] = -INF;
				}
				else
				{
					if (b[i] > a[j]) w[i][j] = 0;
					else w[i][j] = -INF;
				}
			}
		for (int i = 1; i <= m; i++)
			for (int j = n + 1; j <= m; j++)
			w[i][j] = b[i];
		ans = max(ans, KM());
	}
	pt(ans);
	return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-10-23 23:00:51

Codeforces 321B Ciel and Duel KM的相关文章

Codeforces 321B Ciel and Duel

题意:对方有N张卡牌,每一张卡牌要么是攻击模式要么是防守模式,你有M张卡牌,都是攻击模式 ,每张卡牌都有一个值,你可以进行一下的任意操 1)如果对方牌都被你消灭了,那么你任选一张没有选过的牌是对方遭受牌值的攻击. 2)可以选择一张没有选过值为X的牌,攻击对方一张攻击模式值为Y 的牌  对对方造成(X-Y)的伤害并把牌消灭 X必须 大于等于Y 3)可以选择一张没有选过值为X的牌,攻击对方一张防守模式值为Y 的牌  对对方不造成伤害,把对方牌消灭. X必须大于Y 解题思路:暴力 + DP? 解题代码

Codeforces G. Ciel the Commander

题目描述: Ciel the Commander time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output Now Fox Ciel becomes a commander of Tree Land. Tree Land, like its name said, has n cities connected by n?-?1 undire

网络流(费用流)CodeForces 321B:Ciel and Duel

Fox Ciel is playing a card game with her friend Jiro. Jiro has n cards, each one has two attributes: position (Attack or Defense) and strength. Fox Ciel has m cards, each one has these two attributes too. It's known that position of all Ciel's cards

CodeForces 321C Ciel the Commander

Ciel the Commander Time Limit: 1000ms Memory Limit: 262144KB This problem will be judged on CodeForces. Original ID: 321C64-bit integer IO format: %I64d      Java class name: (Any) Now Fox Ciel becomes a commander of Tree Land. Tree Land, like its na

Codeforces 321E Ciel and Gondolas

传送门:http://codeforces.com/problemset/problem/321/E [题解] 首先有一个$O(n^2k)$的dp. # include <stdio.h> # include <string.h> # include <iostream> # include <algorithm> // # include <bits/stdc++.h> using namespace std; typedef long lon

CodeForces 321A Ciel and Robot(数学模拟)

题目链接:http://codeforces.com/problemset/problem/321/A 题意:在一个二维平面中,開始时在(0,0)点,目标点是(a.b),问能不能通过反复操作题目中的指令,从原点移动到目标点. 分析:如果一次完毕全部的命令后.移动到了(xx,yy),而且从(Xi.Yi)反复操作k次指令到达目标点.则能够列出方程 Xi + k * xx = a && Yi + k * yy = b.然后解出k.推断k是否大于等于0就可以. #include <cstdi

Codeforces 321C Ciel the Commander 树分治裸题

题目链接 题意: 给定一棵树,要用字母A-Z 填到每个节点上 字母可以无限使用,但A至多只能用一次 目标:对于任意两个相同字母的节点,他们之间的路径上必须有至少一个节点的字母比他们小 例如:在两个C之间至少要有一个A 或者一个B 问: 输出填涂方案. 树分治即可,最多支持2^25个节点,不会无解. #include <iostream> #include <string> #include <vector> #include <cstring> #inclu

codeforces 321E Ciel and Gondolas 四边形不等式

题目大意:给定n个人,需要分k次过河,两个人i,j如果同乘一条船就会产生ai,j的代价,求最终代价的最小值 这个玩应显然满足四边形不等式(虽然我并不知道这个不等式是啥 然后就是决策单调(虽然我并不知道为何满足四边形不等式一定决策单调 然后就能分治做辣... 定义Solve(l,r,optl,optr)表示当前在处理区间[l,r],最优决策区间为[optl,optr] 然后我们用区间[optl,min(optr,mid?1)]的f值来更新f[mid],并记录最优决策点pos 那么[l,mid?1]

Codeforces 321A Ciel and Robot 枚举答案

题目链接 枚举机器人走的最后一步,用终点坐差后计算周期次数 trick:周期次数要>=0 #include <iostream> #include <string> #include <vector> #include <cstring> #include <cstdio> #include <map> #include <queue> #include <algorithm> #include <